//
// See license.txt
//
package lv.tsi.ai;

import java.text.DecimalFormat;
import java.util.Random;

import lv.tsi.util.SynthNote;

/**
 *  ,    
 *        
 *
 * struct PopStr {
 *     char Genome [L + 1];
 *     double Fitness;
 * } Pop[PopSize], NewPop[PopSize];
 *
 * // 
 *
 * GenerateRandomPopulation (Pop);
 * EvaluatePopulation (Pop);
 * while (Not_Done) (
 *     DoTournamentSelection (Pop, NewPop);
 *     ModifyPopulation (NewPop);
 *     Switch (Pop, NewPop);
 *     EvaluatePopulation (Pop);
 * }
 *
 * @version 0.0.1 5 February 2001
 * @author Alexey Vasilyev
 */
public class TestMusic {

    //private final static int GENERATIONS_NUMBER = 50; // Number of iteractions
    private final static int POP_SIZE           = 10;   // Number of populations
    private final static int GENOME_SIZE        = 4*20; // Number of bits in genome code

    private static void initPopStr(PopStrA[] pop) {
        for (int i=0; i<POP_SIZE; i++)
             pop[i] = new PopStrMusic(GENOME_SIZE);
    }

////////////////////////////
    public static void main(String s[]) {
        //GeneticAlgorithm ga = new GeneticAlgorithm(POP_SIZE, GENOME_SIZE);
        GeneticAlgorithm ga = new GeneticAlgorithm();
        PopStrA[] pop = new PopStrMusic[POP_SIZE];
        PopStrA[] newPop;
        initPopStr( pop );
        ga.GenerateRandomPopulation (pop);
        ga.EvaluatePopulation (pop);
        ga.Dump(pop);
        /*int i = GENERATIONS_NUMBER;
        while (i-- > 0) {
            System.out.println("\nGeneration: " + (GENERATIONS_NUMBER-i) ) ;
            initPopStr(newPop = new PopStrMusic[POP_SIZE]);
            //ga.DoTournamentSelection (pop, newPop);
            ga.DoReproduction(pop, newPop);
            ga.ModifyPopulation (newPop);
            ga.Switch (pop, newPop);
            ga.EvaluatePopulation(pop);
            ga.Dump(pop);
        } */
        char[] c = { '0','0','0','0',
                     '0','0','1','0',
                     '1','0','1','0',
                     '1','1','1','1' };
        int[] in = PopStrMusic.mapStringToNotes(c);
        //for (int i=0; i<in.length; i++)
        //    System.out.println("Test: " + in[i]);
        //System.out.println( "Notes: " + PopStrMusic.mapIntToNoteNames(in) );
        for (int i=0; i<pop.length; i++)
            System.out.println("Test: " + PopStrMusic.mapIntToNoteNames( PopStrMusic.mapStringToNotes(pop[i].genome)) );

        SynthNote syn = new SynthNote();
        syn.playMelody( ((PopStrMusic)pop[0]).getNotes() );
        syn.close();
        try {
            Thread.currentThread().sleep( 10000 );  // 10 sec
        } catch (Exception e) {}
    }

}