//
// See license.txt
//
package lv.tsi.graphics;

import lv.tsi.util.*;
import lv.tsi.ai.*;

/**
 *  ,    
 *        
 *
 * struct PopStr {
 *     char Genome [L + 1];
 *     double Fitness;
 * } Pop[PopSize], NewPop[PopSize];
 *
 * // 
 *
 * GenerateRandomPopulation (Pop);
 * EvaluatePopulation (Pop);
 * while (Not_Done) (
 *     DoTournamentSelection (Pop, NewPop);
 *     ModifyPopulation (NewPop);
 *     Switch (Pop, NewPop);
 *     EvaluatePopulation (Pop);
 * }
 *
 * @version 0.3.1 10 March 2001
 * @author Alexey Vasilyev
 */
public class MusicProducer implements java.io.Serializable {

    //private final static int GENERATIONS_NUMBER = 50; // Number of iteractions
    int pop_size;    // Number of populations
    int genome_size; // Number of bits in genome code

    private void initPopStr(PopStrA[] pop) {
        for (int i=0; i<pop_size; i++)
             pop[i] = new PopStrMusic(genome_size);
    }

    public PopStrMusic[] pop;
    PopStrMusic[] newPop;
    GeneticAlgorithmMusic iga;
    int generation;

    public MusicProducer() {
        this(20, 4*10);
    }

    public MusicProducer(int pop_size, int genome_size) {
        if (pop_size % 2 != 0) {
            //this.pop_size    = pop_size / 2 * 2;
            System.out.println( "WARN  The incoming population size '" + pop_size + "' must be divisible by 2." );
        } else
            this.pop_size    = pop_size;
        if (genome_size % 4 != 0) {
            //this.pop_size    = pop_size / 2 * 2;
            System.out.println( "WARN  The incoming genome size '" + genome_size + "' must be divisible by 4." );
        } else
            this.genome_size = genome_size;
        iga = new GeneticAlgorithmMusic();
        pop = new PopStrMusic[pop_size];
        generation = 0;
        initPopStr( pop );
        iga.GenerateRandomPopulation (pop);
        Log.debug("");
        Log.debug("Generation: 0");
        iga.Dump(pop);
    }

    public void next() {
        generation++;

        iga.EvaluatePopulation (pop);
        initPopStr(newPop = new PopStrMusic[pop_size]);

        //iga.DoTournamentSelection (pop, newPop);
        iga.DoReproduction(pop, newPop);

        Log.debug("");
        Log.debug("Before modification: ");
        iga.Dump(newPop);
        iga.ModifyPopulation (newPop);
        Log.debug("");
        Log.debug("After modification: " );
        iga.Dump(newPop);

        iga.Switch (pop, newPop);
        //iga.EvaluatePopulation(pop);
        Log.debug("");
        Log.debug("Generation: " + generation);
        iga.Dump(pop);
    }

}
