//
// See license.txt
//
package lv.tsi.graphics;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.sound.midi.*;
import javax.sound.sampled.*;
import java.util.Vector;
import java.awt.event.*;

import lv.tsi.ai.*;

/**
 * Panel where button "Next >" and label "Generation" are located.
 *
 * @version 0.3.0 9 March 2001
 * @author Alexey Vasilyev  
 */
public class NextPanel extends JPanel implements ActionListener {

    private JButton btnNext;
    private JLabel  lblGener = new JLabel();

    public NextPanel() {
        super( new BorderLayout() );
        setBorder(new EmptyBorder(5,5,5,5));
        try {
            btnNext = new JButton("Next", new ImageIcon( this.getClass().getResource("/lv/tsi/images/next.gif")) ); 
            btnNext.setHorizontalTextPosition( SwingConstants.LEFT );
        } catch (Exception e) {
            btnNext = new JButton("Next >>");
        }
        btnNext.setMnemonic('N');
        btnNext.addActionListener(this);
        add( BorderLayout.EAST, btnNext  );
        add( BorderLayout.WEST, lblGener );
        lblGener.setForeground(Color.darkGray);
    }

    // "Next" button pressed
    public void actionPerformed(ActionEvent e) {
        next();
    }

    public void next() {
        System.out.println("Generation: " + ComposerUI.prod.generation);
        //  -------------------------------------------------
        // | Process new generation
        //  -------------------------------------------------
        ComposerUI.prod.next();
        //  -------------------------------------------------
        // | Set new population to table
        //  -------------------------------------------------
        ComposerUI.pnlIGA.refreshGeneration();
        updateGeneration();
    }

    public void updateGeneration() {
        lblGener.setText("Generation: " + ComposerUI.prod.generation);
    }

}
